// TeXworksScript
// Title:  Manual Version/Progress Copy Save
// Description: Automatically saves with a timestamped name document in progress folder
// Author:  Paul Norman
// Version: 0.1
// Date: 2011-06-21
// Script-Type: standalone
// //Script-Type: hook
// //Hook: LoadFile
// Shortcut: Alt+M, Alt+V, Alt+S

  

 const twConst = {
// cut down Global
           SystemAccess_NotAttempted : -1,
                     SystemAccess_OK : 0,
                 SystemAccess_Failed : 1,
       SystemAccess_PermissionDenied : 2

              }; // end twConst

 twPan = { 
   // cut down Global
 
 //%:     select(message, optionsArray) : string

            select : function(message, optionsArray){
            
         chosen = TW.getItem(null, message, message, optionsArray, 0, true); // true - editable

             if (chosen === null)
               {return "";}
      
                    return  chosen;
										
										}, // End.  twPan.select()
										
//%:     ##file_get_contents## : string;                                
file_get_contents : function(){


                 if (this.file_get_contents.arguments.length == 0)
                       {
                       fileNameFullPath = TW.app.getOpenFileName(); 
                       }
                     else
                       {
                        fileNameFullPath = this.file_get_contents.arguments[0];
                        }

                               var res = TW.readFile(fileNameFullPath);
                                 switch (res.status)
                                 {
                                   case twConst.SystemAccess_PermissionDenied:
                                   case twConst.SystemAccess_Failed:
  												 this.alert(res.message);
												var text = undefined;
											break;

                                   case twConst.SystemAccess_OK:  												 
												var text = res.result;
											break;
                                  }

                                return text;
         
                                               }, // End. twPan.file_get_contents
                                               
//%:     file_put_contents : void;

         file_put_contents : function(fileNameFullPath , fileContents){
                                 var  status = TW.writeFile(fileNameFullPath, fileContents); // pathFileName, Contents (- utf-8) 
                                 switch (status)
                                 {
                                   case twConst.SystemAccess_PermissionDenied:
                                   case twConst.SystemAccess_Failed:
  									 this.alert('Please Turn on File Writing in \n\ Edit Menu / Preferences / Scripts');
											break;

                                 } // End. switch (status)
 
 
         
                            }, // End.  twPan.file_put_contents		
//%:     ##getDate## : () ; // can accept an argument for date format 'dmy' or 'ydm' or 'ymd', if not present dropdown box is shown.
   
           getDate : function(){                            
                            
                                  // Altered from: http://www.tizag.com/javascriptT/javascriptdate.php  
      	var currentTime = new Date();
      	var month = currentTime.getMonth() + 1;
		var day = currentTime.getDate() + ''; // force cast for length test
		var year = currentTime.getFullYear();
		var hour = currentTime.getHours()+ '';
        var minute = currentTime.getMinutes()+ '';
        var second = currentTime.getSeconds()+ '';
		
		
		if (day.length < 2){day = "0" + day;} 
		    month = month + '';  // force cast for length test
		if (month.length < 2){month = "0" + month;}      
        if (hour.length < 2){hour = "0" + hour;}
        if (minute.length < 2){minute = "0" + minute;}
        if (second.length < 2){second = "0" + second;}        
        
      
     if (this.getDate.arguments.length > 0)
       {
         
         wantedFormat = this.getDate.arguments[0].toLowerCase();
         
         switch (wantedFormat)
          {
           case 'dmy': // could just use default below HERE FOR COMPLETENESS
              result = day + '-' + month + '-'   + year;
            break;
            
           case 'ydm':
              result = year + '-' + day + '-' + month;
            break; 
            
           case 'ymd':
              result = year + '-' + month + '-' + day;
            break; 
            
           case 'ymdhms':
              result = year + '-' + month + '-' + day 
                      + '--' + hour + '-' + minute + "-" + second;
            break;             
            
           default:
              result = day + '-' + month + '-'  + year;
          }
       
        }
      else
      {
         var result = this.select('Select Format', 
                                   [ day + '-' + month + '-'   + year,
                                    year + '-' + day + '-' + month, 
                                    year + '-' + month + '-'    + day
                                    ]);      
      }
      
        return result;
       
                            }, // End twPan.getDate                            			
                            
//%:  emptyString( something : empty string?) : boolean  

 // after http://stackoverflow.com/questions/154059/what-is-the-best-way-to-check-for-an-empty-string-in-javascript/3215653#3215653  by Jet 
		 emptyString : function (e) 
		 {
		         switch(e) {
		                        case "":
		                        case 0:
		                        case "0":
		                        case null:
		                        case false:
		                        case undefined:
		                            return true;
														break;		
		                                default : return false;
		                    }
		 }  // End.  emptyString( something : empty string?) : boolean    										
 
 }

 //  eval(TW.app.getGlobal("helper_twPan")); //  Comment if NOT Needed - This includes PhpJs ($P), twConst, msgBox, twPan ($tw), string.toTitleCase() 

  function showResult(fileDetail)
          {
          message = "<html><body><br />Progress Copy Completed: <br /><a  href=\"texworks:" + fileDetail + "\">" +  fileDetail + "</a><br /></body></html>"; 
           TW.information(null, "Action", message);
           } 

     var dateTime = twPan.getDate('ymdhms');
     
     var baseName =  TW.target.fileName ;
     var fileExtn =  baseName.substr(baseName.lastIndexOf("."));
         baseName =  baseName.substr(0, baseName.lastIndexOf(".")); 
     var nameStem = baseName.substr(baseName.lastIndexOf("/")+1);
  
     var saveAsName = baseName
                       + '-' + dateTime + fileExtn;
     
                        
 //     var message = "<html><body>Progress Copy Cancelled: <u>"+ dateTime +"</u> <br /></body></html>";
 
 var places =      
 twPan.file_get_contents("auto_Save_responses.txt").split("\n");   
 
 
  var options = [
                twPan.file_get_contents("autoSaveAs-Chosen.txt")
                ].concat(places);        
     
 var ans =twPan.select("Save Progress Copy?",options); 
    
  if (twPan.emptyString(ans) == true) // user cancelled
    {
     ans = "No";
     }
     
  if (ans.indexOf("/") > -1) // user choice is a file path
    {
     twPan.file_put_contents("autoSaveAs-Chosen.txt", ans);
     //This will appear at the top of the dropdown box of choices next run                     
        }   
     
     switch (ans)
     {
      case "No":
          break;
       
      case "In Same Directory":
                   twPan.file_put_contents(saveAsName, TW.target.text);                    
                   showResult(saveAsName);
          break;
      
      case "Other Place":
             
       saveAsName =  TW.app.getSaveFileName(saveAsName);
    if (twPan.emptyString(saveAsName) == false)
      {
	               twPan.file_put_contents(saveAsName, TW.target.text);                    
	                           
	    var saveAsNamePath = saveAsName.substr(0, saveAsName.lastIndexOf("/") +1)                   
	    var  addPath = true;

	      for (x in places)
	         {
	         
	          if (places[x] == saveAsNamePath)
	            {
	             addPath = false;
	             break;
	             }
	         }   
	       if (addPath == true)
	         {
	          twPan.file_put_contents("auto_Save_responses.txt", 
	                                  places.join("\n") +"\n" + saveAsNamePath);
	           }  	       
	       
	      showResult(saveAsName);
	        }    
          break;
          
         default:
                 twPan.file_put_contents(ans 
                                         + nameStem
                                         + '-' + dateTime + fileExtn
                                         , TW.target.text);                    
          showResult(ans + nameStem + '-' + dateTime + fileExtn);                               
          break;
     }
     
     null;